import pytest
from asun.main import check_membership
from asun.utilities import delete_spaces, remove_redundant_eps

test_cases_membership_check = [
    ('a*', 'a', True)
    , ('a*', 'b', False)
    , ('a*', 'aaa', True)
    , ('a*', '$', True)
    , ('aa*', 'a', True)
    , ('aa*', 'b', False)
    , ('aa*', 'aa', True)
    , ('aa*', '$', False)
    , ('(aa)*', '$', True)
    , ('(aa)*', 'a', False)
    , ('(aa)*', 'aaa', False)
    , ('(aa)*', 'asdfadfsfs', False)
    , ('(aa)*', 'aaaa', True)
    , ('!(aa*)', 'a', False)
    , ('!(aa*)', 'b', True)
    , ('!(aa*)', 'aa', False)
    , ('!(aa*)', '$', True)
    , ('(ab)*', '$', True)
    , ('(ab)*', 'ab', True)
    , ('(ab)*', 'a', False)
    , ('(ab)*', 'b', False)
    , ('(ab)*', 'adsdfsfgf', False)
    , ('(ab)*', 'ababab', True)
    , ('(ab)*', 'aabaabaab', False)
    , ('(a*)b', '$', False)
    , ('(a*)b', 'bbba', False)
    , ('(a*)b', 'bbbb', False)
    , ('(a*)b', 'aaaaaa', False)
    , ('(a*)b', 'ab', True)
    , ('(a*)b', 'b', True)
    , ('(a*)b', 'aaaaaab', True)
    , ('((a*)b)*', 'aaaaaab', True)
    , ('((a*)b)*', '$', True)
    , ('((a*)b)*', 'b', True)
    , ('((a*)b)*', 'ab', True)
    , ('((a*)b)*', 'abaabaaab', True)
    , ('((a*)b)*', 'aabaabaab', True)
    , ('((a*)b)*', 'dawdwd', False)
    , ('(a*) | (b*)', '$', True)
    , ('(a*) | (b*)', 'c', False)
    , ('(a*) | (b*)', 'rrgjrxtsy', False)
    , ('(a*) | (b*)', 'tmxdtlzvgiao', False)
    , ('(a*) | (b*)', 'j', False)
    , ('(a*) | (b*)', 'aaaaaaaaa', True)
    , ('(a*) | (b*)', 'bbbbbbbbbbbbbbbbbbb', True)
    , ('(a*) | (b*)', 'bbbbbbbbbbbbbbbbbb', True)
    , ('(a*) | (b*)', 'bbbbbb', True)
    , ('(a*) | (b*)', 'bbbbbbbbbbb', True)
    , ('(a*) | (b*)', 'bbbbbbbbbbbbbbbbbbbb', True)
    , ('(a*) | (b*)', 'bb', True)
    , ('!((a*) | (b*))', '$', False)
    , ('!((a*) | (b*))', 'c', True)
    , ('!((a*) | (b*))', 'rrgjrxtsy', True)
    , ('!((a*) | (b*))', 'aaaaaaaaa', False)
    , ('!((a*) | (b*))', 'bbbbbbbbbbbbbbbbbbb', False)
    , ('!((a*) | (b*))', 'bbbbbbbbbbbbbbbbbb', False)
    , ('((a*) | (b*))c', 'c', True)
    , ('((a*) | (b*))c', 'd', False)
    , ('((a*) | (b*))c', '$', False)
    , ('((a*) | (b*))c', 'ctdwejjjlyc', False)
    , ('((a*) | (b*))c', 'sjxltqpvbvqfc', False)
    , ('((a*) | (b*))c', 'xroc', False)
    , ('((a*) | (b*))c', 'ac', True)
    , ('((a*) | (b*))c', 'oc', False)
    , ('((a*) | (b*))c', 'aaaaaaaaa', False)
    , ('((a*) | (b*))c', 'bbbbbbbbbbb', False)
    , ('((a*) | (b*))c', 'aaaaaaaaac', True)
    , ('((a*) | (b*))c', 'bbbbbbbbbbbc', True)
    , ('((aaa*) | (bbb*))c', '$', False)
    , ('((aaa*) | (bbb*))c', 'b', False)
    , ('((aaa*) | (bbb*))c', 'a', False)
    , ('((aaa*) | (bbb*))c', 'bbbbbbbbbbbc', True)
    , ('((aaa*) | (bbb*))c', 'aaaac', True)
    , ('((aaa*) | (bbb*))c', 'bc', False)
    , ('((aaa*) | (bbb*))c', 'ac', False)
    , ('((aaa*) | (bbb*))c', 'vvzyrzxudlqc', False)
    , ('((aaa*) | (bbb*))c', 'nenjaupdemkbccuwerkc', False)
    , ('((aaa*) | (bbb*))c', 'sc', False)
    , ('((aaa*) | (bbb*))c', 'ktpxkjhsmymgcfdbmjec', False)
    , ('((aaa*) | (bbb*))c', 'vpjrflbuuvfdxowc', False)
    , ('(a & c)', '$', False)
    , ('(a & c)', 'a', False)
    , ('(a & c)', 'c', False)
    , ('(a & c)', 'sdfsdfsf', False)
    , ('(a & c)', 'aaaaac', False)
    , ('(a & c)', 'cccca', False)
    , ('(a & c)', 'aaaaaa', False)
    , ('(a & c)', 'ccccccc', False)
    , ('(aa) & (a*)', '$', False)
    , ('(aa) & (a*)', 'a', False)
    , ('(aa) & (a*)', 'b', False)
    , ('(aa) & (a*)', 'aaa', False)
    , ('(aa) & (a*)', 'aa', True)
    , ('(aa) & (a*)', 'wdawdad', False)
    , ('(aa) & (a*)', 'wdawdad', False)
    , ('!((aa) & (a*))', '$', True)
    , ('!((aa) & (a*))', 'a', True)
    , ('!((aa) & (a*))', 'b', True)
    , ('!((aa) & (a*))', 'aaa', True)
    , ('!((aa) & (a*))', 'aa', False)
    , ('!((aa) & (a*))', 'wdawdad', True)
    , ('(((aa) & (a*)) | (b & (b*)))c', 'aac', True)
    , ('(((aa) & (a*)) | (b & (b*)))c', 'bc', True)
    , ('(((aa) & (a*)) | (b & (b*)))c', 'aa', False)
    , ('(((aa) & (a*)) | (b & (b*)))c', '$', False)
    , ('(((aa) & (a*)) | (b & (b*)))c', 'c', False)
    , ('(((aa) & (a*)) | (b & (b*)))c', 'aaac', False)
    , ('(((aa) & (a*)) | (b & (b*)))c', 'bbc', False)
    , ('(((aa) & (a*)) | (b & (b*)))c', 'wdawwdwda', False)
    , ('!((((aa) & (a*)) | (b & (b*)))c)', 'aac', False)
    , ('!((((aa) & (a*)) | (b & (b*)))c)', 'bc', False)
    , ('!((((aa) & (a*)) | (b & (b*)))c)', 'aa', True)
    , ('!((((aa) & (a*)) | (b & (b*)))c)', '$', True)
    , ('!((((aa) & (a*)) | (b & (b*)))c)', 'c', True)
    , ('!((((aa) & (a*)) | (b & (b*)))c)', 'aaac', True)
    , ('!((((aa) & (a*)) | (b & (b*)))c)', 'bbc', True)
    , ('!((((aa) & (a*)) | (b & (b*)))c)', 'wdawwdwda', True)
    , ('((!a) & ((aa) & (a*)))', 'a', False)
    , ('((!a) & ((aa) & (a*)))', 'aaa', False)
    , ('((!a) & ((aa) & (a*)))', 'aa', True)
    , ('((!a) & ((aa) & (a*)))', 'b', False)
    , ('((!a) & ((aa) & (a*)))', '$', False)
    , ('((!a) & ((aa) & (a*)))c', 'a', False)
    , ('((!a) & ((aa) & (a*)))c', 'aaa', False)
    , ('((!a) & ((aa) & (a*)))c', 'aac', True)
    , ('((!a) & ((aa) & (a*)))c', 'b', False)
    , ('((!a) & ((aa) & (a*)))c', '$', False)
    , ('((!a) & ((aa) & (a*)))c', 'aa', False)
    , ('((!a) & ((aa) & (a*)))c', 'dawdawdad', False)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', '$', True)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', 'c', True)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', 'ccccccc', True)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', 'aac', True)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', 'aa', False)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', 'b', False)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', 'aaac', False)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', 'asdasdasdasd', False)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', 'aabbc', False)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', 'baac', False)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', 'ccccccccb', False)
    , ('(((!a) & ((aa) & (a*)))c) | (c*)', 'dasfadfadf', False)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', '$', False)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', 'c', False)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', 'ccccccc', False)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', 'aac', True)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', 'aa', True)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', 'b', True)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', 'aaac', True)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', 'asdasdasdasd', True)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', 'aabbc', True)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', 'baac', True)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', 'ccccccccb', True)
    , ('!((((!a) & ((aa) & (a*)))c) | (c*))', 'dasfadfadf', True)
    , ('(((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)', '$', False)
    , ('(((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)', 'b', False)
    , ('(((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)', 'c', False)
    , ('(((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)', 'aac', True)
    , ('(((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)', 'bd', True)
    , ('(((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)', 'bbd', False)
    , ('(((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)', 'ac', False)
    , ('(((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)', 'd', False)
    , ('(((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)', 'cddafsdfsdc', False)
    , ('((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*)', '$', True)
    , ('((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*)', 'b', False)
    , ('((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*)', 'aac', True)
    , ('((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*)', 'bd', True)
    , ('((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*)', 'e', True)
    , ('((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*)', 'eeeeeee', True)
    , ('((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*)', 'ac', False)
    , ('((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*)', 'bbd', False)
    , ('((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*)', 'd', False)
    , ('((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*)', 'dhcschsdchg', False)
    , ('!(((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*))', '$', False)
    , ('!(((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*))', 'b', True)
    , ('!(((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*))', 'aac', True)
    , ('!(((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*))', 'bd', True)
    , ('!(((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*))', 'e', False)
    , ('!(((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*))', 'eeeeeee', False)
    , ('!(((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*))', 'ac', True)
    , ('!(((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*))', 'bbd', True)
    , ('!(((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*))', 'd', True)
    , ('!(((((!a) & ((aa) & (a*)))c) | (((!(bb)) & (b & b*))d)) | (e*))', 'dhcschsdchg', True)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) & (c(c*)))', 'dhcschsdchg', False)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) & (c(c*)))', '$', False)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) & (c(c*)))', 'aaab', False)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) & (c(c*)))', 'bb', False)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) & (c(c*)))', 'bbd', False)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) & (c(c*)))', 'c', False)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) & (c(c*)))', 'dsdfdssdsf', False)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) & (c(c*)))', 'aab', True)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) & (c(c*)))', 'aaaab', True)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) & (c(c*)))', 'bd', True)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) & (c(c*)))', 'ccc', True)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) $ (c(c*)))', 'cccc', True)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) $ (c(c*)))', 'ccc', False)
    , ('((((!a) & ((aa)* & (a*)))b) | (((!(bb)) & (b & b*))d)) | ((ccc) $ (c(c*)))', 'cccccccccc', True)

]

test_cases_delete_spaces = [
    ('  a   *   ', 'a*')
    , ('   a  a       a', 'aaa')
    , (' (   a   *)    | (   b*   )', '(a*)|(b*)')
]

test_cases_remove_redundant_eps = [
    ('$', '$')
    , ('$$$$$$$$$$$$$$$$', '$')
    , ('a$$$$$$$$$$$b$$$$$$$$$$$c', 'abc')
]


@pytest.mark.parametrize('reg_ex, word, res', test_cases_membership_check)
def test_parametrized_for_membership_check(reg_ex, word, res):
    assert res == check_membership(reg_ex, word)


@pytest.mark.parametrize('inp_str, res', test_cases_delete_spaces)
def test_parametrized_for_delete_spaces(inp_str, res):
    assert res == delete_spaces(inp_str)


@pytest.mark.parametrize('inp_str, res', test_cases_remove_redundant_eps)
def test_parametrized_for_remove_redundant_eps(inp_str, res):
    assert res == remove_redundant_eps(inp_str)
